#include <stdio.h>
#include <string.h>
#include <math.h>

#include "ff.h"
#include "v1.h"

/* Ylanalysaattorin paksuus */
static int PAX;
static int hetki;

static void Init(void)
{
	int a;
	
	PAX = LINE*400/768;
	
	/* Draw the white lines */
	memset(&Vid[0],           127, COL);
	memset(&Vid[(PAX-1)*COL], 127, COL);
	
	hetki = 0;
	
	/* Set the palette */
	for(a=0; a<128; a++)
	{
		unsigned char *Pal = &Palette[(a+128)*3];
		
		*Pal++ = ((    a)   * 65535 / 127 - a*100) >> 8;
		*Pal++ = abs(a-64) * 255 / 127;
		*Pal   = (127-a)   * 255 / 127;
		
		/* leave the first sixteen untouched */
		if(a >= 16)
		{
			Pal = &Palette[a*3];
			*Pal++ = (a<0x50) ? 0 : (a-0x50) * 255 / 0x2F;
			*Pal++ = (a<0x20) ? 0 : (a-0x20) * 255 / 0x5F;
			*Pal   = a * 255 / 127;
		}
	}
	
	fb_writepalette();
}

static void Done(void)
{
}

static void View(void)
{
	int a;
	unsigned char *Ptr;
	char fps_str[32];
	
	bzero(Vid + PAX*COL, (LINE-PAX)*COL);
	
	fb_center(PAX+8,  "Spectrum analyzer by Bisqwit");
	fb_center(PAX+24, "Uses fftw");

	sprintf(fps_str, "FPS=%.1f", FPS);
	fb_center(PAX+40, fps_str);
	
	for(a=0; a<COL; a++)
	{
		register int y, Dy;
		fftw_real dy;
		
		/* This here may look strange, but    *
		 * because there is N/2 instead of N, *
		 * here is also 200 instead of 100.   */
		register int nyt = (a * (N*V1_KAISTA_PROS/200)/(COL-1));
		
		dy = (Avg[nyt]/AvgCount - Power[nyt]) * (LINE-PAX) / 50.0;
		
		Ptr = Vid + a + COL * ((LINE*3 + PAX) / 4);
		
		if(dy < 0)
		{
			if(dy < (PAX-(LINE*3+PAX)/4))dy = (PAX-(LINE*3+PAX)/4);
			for(Dy=dy, y=Dy; ++y<0; Ptr-=COL)*Ptr = 128 + y*127/Dy;
		}
		else
		{
			if(dy > (LINE-(LINE*3+PAX)/4))dy = (LINE-(LINE*3+PAX)/4);
			
			for(Dy=dy, y=Dy; --y>0; Ptr+=COL)*Ptr = 128 + y*127/Dy;
		}
		
		if(a == COL * V1_NAUHA_PROS / V1_KAISTA_PROS)
		{
			Ptr = Vid+a+PAX*COL;
			for(Dy=LINE-PAX; (Dy-=5)>=0; Ptr+=COL*5)*Ptr = 127;
		}
	}
	
	Ptr = Vid + hetki + (PAX-1)*COL;
	
	for(a=1; a<PAX-1; a++)
	{
		/* This here may look strange, but    *
		 * because there is N/2 instead of N, *
		 * here is also 200 instead of 100.   */
		register int dy, nyt = (a * (N*V1_NAUHA_PROS/200) / PAX);
		
		dy = sqrt(fabs(Power[nyt]-Avg[nyt]/AvgCount)) * 10.0;
		
		if(dy>127-16)dy=127-16;
		
		if(dy<0)dy=0;

		Ptr -= COL;
		
		/* CHECKME: Does this work ok on other-endian machines? */
		*(long *)Ptr = dy + 0x00008810;
	}		
	
	if(++hetki == COL)hetki = 0;
}

Viewer V1 = {fb_is_required, 0, Init, Done, View};
